; docformat = 'rst'

;+
; Simple example of displaying an image in object graphics.
;   
; :Params:
;    im : in, required, type="2,3D numeric array"
;       image to display
;
; :Keywords:
;    _extra : in, optional, type=keywords
;       keywords to IDLgrImage::init or IDLgrWindow::init
;-
pro mg_ogimage_example, im, _extra=e
  compile_opt strictarr

  view = obj_new('IDLgrView')
  
  model = obj_new('IDLgrModel')
  view->add, model
    
  image = obj_new('IDLgrImage', im, _extra=e)
  model->add, image
  image->getProperty, dimensions=dims
  
  view->setProperty, viewplane_rect=[0, 0, dims - 1L]

  window = obj_new('IDLgrWindow', dimensions=dims, graphics_tree=view, _extra=e)
  window->draw
end